﻿using System;
using System.Collections.Generic;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace InternshipSystem.Api.Converters
{
    public class StringArrayConverter<TItem> : JsonConverter
    {
        public override void WriteJson(JsonWriter writer, object value, JsonSerializer serializer)
        {
            throw new NotImplementedException();
        }

        public override object ReadJson(JsonReader reader, Type objectType, object existingValue, JsonSerializer serializer)
        {
            var token = JToken.Load(reader);

            if (token.Type == JTokenType.Array)
            {
                return token.ToObject<List<TItem>>();
            }
            
            return new List<TItem>
            {
                token.ToObject<TItem>()
            };
        }

        public override bool CanConvert(Type objectType)
        {
            return objectType == typeof(List<TItem>);
        }

        public override bool CanWrite => false;
    }
}