﻿using FluentValidation;

namespace InternshipSystem.Api.Queries
{
    public class InternshipTypeFrom
    {
        public long? Id { get; set; }
        public string Label { get; set; }
        public string LabelEng { get; set; }
        public string Description { get; set; }
        public string DescriptionEng { get; set; }
        
        public class Validator : AbstractValidator<InternshipTypeFrom>
        {
            public Validator()
            {
                RuleFor(t => t.Id).NotNull()
                    .When(t =>
                        string.IsNullOrEmpty(t.Label) || string.IsNullOrEmpty(t.LabelEng));
                RuleFor(t => t.Label).NotEmpty()
                    .When(t => !t.Id.HasValue);
                RuleFor(t => t.LabelEng).NotEmpty()
                    .When(t => !t.Id.HasValue);
            }
        }
    }
}