﻿using System;
using FluentValidation;
using InternshipSystem.Core.Entity.Internship;

namespace InternshipSystem.Api.Queries
{
    public class RegistrationFormQuery
    {
        public CompanyForm Company { get; set; }
        public BranchOfficeForm BranchOffice { get; set; }
        public DateTime? Start { get; set; }
        public DateTime? End { get; set; }
        public InternshipType Type { get; set; }

        public class Validator : AbstractValidator<RegistrationFormQuery>
        {
            public Validator()
            {
                RuleFor(rfq => rfq.Company)
                    .SetValidator(new CompanyForm.Validator());
                RuleFor(rfq => rfq.BranchOffice)
                    .SetValidator(new BranchOfficeForm.Validator());
                RuleFor(rfq => rfq.BranchOffice).NotNull()
                    .When(rfq => rfq.Company != null);
            }
        }
    }
}