﻿using FluentValidation;

namespace InternshipSystem.Api.Queries
{
    public class StaticPageForm
    {
        public long? Id { get; set; }
        public string AccessName { get; set; }
        public string Title { get; set; }
        public string TitleEng { get; set; }
        public string Content { get; set; }
        public string ContentEng { get; set; }
        
        public class Validator : AbstractValidator<StaticPageForm>
        {
            public Validator()
            {
                RuleFor(sp => sp.Id).NotNull()
                    .When(sp => 
                        string.IsNullOrEmpty(sp.AccessName) || string.IsNullOrEmpty(sp.Title) || 
                        string.IsNullOrEmpty(sp.TitleEng) || string.IsNullOrEmpty(sp.Content) || 
                        string.IsNullOrEmpty(sp.ContentEng));
                RuleFor(sp => sp.AccessName).NotEmpty()
                    .When(sp => !sp.Id.HasValue);
                RuleFor(sp => sp.Title).NotEmpty()
                    .When(sp => !sp.Id.HasValue);
                RuleFor(sp => sp.TitleEng).NotEmpty()
                    .When(sp => !sp.Id.HasValue);
                RuleFor(sp => sp.Content).NotEmpty()
                    .When(sp => !sp.Id.HasValue);
                RuleFor(sp => sp.ContentEng).NotEmpty()
                    .When(sp => !sp.Id.HasValue);
            }
        }
    }
}