﻿using System;
using System.Collections.Generic;

namespace InternshipSystem.Core.Entity
{
    public class ReportField
    {
        public ReportField()
        {
            
        }
        
        public ReportField(string label, string labelEng, string description, string descriptionEng, FieldType fieldType)
        {
            Label = label;
            LabelEng = labelEng;
            Description = description;
            DescriptionEng = descriptionEng;
            FieldType = fieldType;
        }

        public long Id { get; set; }
        public string Label { get; set; }
        public string LabelEng { get; set; }
        public string Description { get; set; }
        public string DescriptionEng { get; set; }
        public FieldType FieldType { get; set; }
    }

    public enum FieldType
    {
        LongText,
        ShortText,
        Select,
        Radial,
        Checkbox
    }

    public class ReportChoiceField : ReportField
    {
        public ReportChoiceField(string label, string labelEng, string description, string descriptionEng,
            FieldType fieldType, string[] choices) : base(label, labelEng, description, descriptionEng, fieldType)
        {
            Choices = choices;
        }
        
        public string[] Choices { get; set; }
    }
}