﻿using FluentValidation;
using FluentValidation.Validators;

namespace InternshipSystem.Core
{
    public class BranchAddress
    {
        public string Street { get; set; }
        public string Building { get; set; }
        public string City { get; set; }
        public string PostalCode { get; set; }
        public string Country { get; set; }

        public class Validator : AbstractValidator<BranchAddress>
        {
            public Validator()
            {
                RuleFor(x => x.Country)
                    .NotEmpty()
                    .WithMessage("error.branch.country.empty");
                RuleFor(x => x.City)
                    .NotEmpty()
                    .WithMessage("error.branch.city.empty");
                RuleFor(x => x.PostalCode)
                    .NotEmpty()
                    .WithMessage("error.branch.postal_code.empty");
                RuleFor(x => x.Street)
                    .NotEmpty()
                    .WithMessage("error.branch.street.empty");
                RuleFor(x => x.Building)
                    .NotEmpty()
                    .WithMessage("error.branch.building.empty");
            }
        }
    }
} 