﻿using FluentValidation;

namespace InternshipSystem.Core
{
    public class Mentor
    {
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string Email { get; set; }
        public string PhoneNumber { get; set; }

        public void UpdateInformation(string firstName, string lastName, string email, string phoneNumber)
        {
            FirstName = firstName ?? FirstName;
            LastName = lastName ?? LastName;
            Email = email ?? Email;
            PhoneNumber = phoneNumber ?? PhoneNumber;
        }

        public class Validate : AbstractValidator<Mentor>
        {
            public Validate()
            {
                RuleFor(x => x.FirstName)
                    .NotEmpty()
                    .WithMessage("error.mentor.first_name.empty");
                RuleFor(x => x.LastName)
                    .NotEmpty()
                    .WithMessage("error.mentor.last_name.empty");
                RuleFor(x => x.Email)
                    .NotEmpty()
                    .WithMessage("error.mentor.email.empty");
                RuleFor(x => x.PhoneNumber)
                    .NotEmpty()
                    .WithMessage("error.mentor.phone_number.empty");
                
            }
        }
    }
}